<?php

namespace Modules\Catalogue\Validator;

use Helpers\Trad\ITrad;
use Helpers\Validator\Validator;

class FormatValidator extends Validator
{
    public function __construct(\PDO $pdo, ITrad $trad)
    {
        $this->pdo = $pdo;
        $this->trad = $trad;
    }

    /**
     * @param array<mixed> $post
     * @param array<mixed> $connecteur
     * @return void
     */
    public function validateForm(&$post, $connecteur)
    {
        $this->isStringSansEspace($this->trad->t('Identification du format'), $post['IDFORMAT'], 1, 30);
        $this->isStringAvecEspace($this->trad->t('Description du format'), $post['DESCFRMT'], 1, 128);

        if ($post['TYPDATAS'] == 'OCI') {
            $this->isStringAvecEspace($this->trad->t('Identifiant panier fournisseur'), $post['RACINEXML_CXML'], 0, 128);
            $post['RACINEXML'] = $post['RACINEXML_CXML'];
        }

        if ($post['TYPDATAS'] == 'cXML') {
            $this->isStringAvecEspace($this->trad->t('Identifiant panier fournisseur'), $post['RACINEXML_OCI'], 0, 128);
            $post['RACINEXML'] = $post['RACINEXML_OCI'];
        }

        if ($post['TYPDATAS'] == 'XML') {
            $this->isStringAvecEspace($this->trad->t('Elément Racine XML'), $post['RACINEXML_XML'], 0, 128);
            $post['RACINEXML'] = $post['RACINEXML_XML'];
        }

        if ($post['TYPDATAS'] == 'OCI' || $post['TYPDATAS'] == 'cXML') {
            foreach ($connecteur as $k => $c) {
                $index = $k+1;
    
                $this->isObligatoire($c['IDCLE'], $index.' - '.$this->trad->t('IDCLE'));
                $this->isInteger($index.' - '.$this->trad->t('ORDRE'), $c['ORDRE'], 1, 9);
                $this->isObligatoire($c['NOM_PARAMETRE'], $index.' - '.$this->trad->t('NOM PARAMETRE'));
                $this->isStringAvecEspace($index.' - '.$this->trad->t('VALEUR_PARAM'), $c['VALEUR_PARAM'], 1, 255);
                $this->isObligatoire($c['TYPE_PARAM'], $index.' - '.$this->trad->t('TYPE PARAM').' '.$index);
            }
        }
    }
}
